package org.apithefire.server.jetty;

import java.net.URL;

import javax.servlet.Servlet;

import org.apithefire.server.Context;
import org.mortbay.jetty.handler.ContextHandlerCollection;
import org.mortbay.jetty.servlet.ServletHolder;
import org.mortbay.jetty.webapp.WebAppContext;

public class JettyContext extends Context {

	private static final String DUMMY_WAR = "dummy_war";
	private static final String DEFAULT_DESCRIPTOR = "DefaultDescriptor.xml";

	@Override
	protected void configure(Object serverImpl) {
		WebAppContext context = new WebAppContext();
		String contextPath = getContextPath();
		URL dummyWar = getClass().getResource(DUMMY_WAR);
		URL defaultDescriptor = getClass().getResource(DEFAULT_DESCRIPTOR);
		Servlet servlet = getServlet();
		
		context.setContextPath(contextPath);
		context.setResourceBase(dummyWar.toString());
		context.setDefaultsDescriptor(defaultDescriptor.toString());

		if (servlet != null) {
			context.addServlet(new ServletHolder(servlet), MATCH_ALL_URL_PATTERN);
		}
		
		org.mortbay.jetty.Server jettyServer = (org.mortbay.jetty.Server) serverImpl;
		ContextHandlerCollection contexts = (ContextHandlerCollection) jettyServer
				.getHandler();

		contexts.addHandler(context);
	}

}
