package org.apithefire.server.jetty;

import org.apithefire.server.Server;
import org.apithefire.server.ServerException;
import org.mortbay.jetty.handler.ContextHandlerCollection;

public class JettyServer extends Server {
	
	@Override
	protected JettyConnector newConnector() {
		return new JettyConnector();
	}

	@Override
	protected JettyContext newContext() {
		return new JettyContext();
	}

	@Override
	protected Object newImplementation() {
		org.mortbay.jetty.Server serverImpl = new org.mortbay.jetty.Server();
		
		serverImpl.setHandler(new ContextHandlerCollection());
		return serverImpl;
	}

	@Override
	protected void start(Object serverImpl) {
		try {
			((org.mortbay.jetty.Server) serverImpl).start();
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new ServerException(e);
		}
	}

	@Override
	protected void join(Object serverImpl) {
		try {
			((org.mortbay.jetty.Server) serverImpl).join();
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new ServerException(e);
		}
	}

	@Override
	protected void stop(Object serverImpl) {
		try {
			((org.mortbay.jetty.Server) serverImpl).stop();
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new ServerException(e);
		}
	}

}
